Index: contrib/ntp/sntp/sntp-opts.c
===================================================================
--- contrib/ntp/sntp/sntp-opts.c	(版本 297264)
+++ contrib/ntp/sntp/sntp-opts.c	(版本 298770)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (sntp-opts.c)
  *
- *  It has been AutoGen-ed  January 20, 2016 at 04:06:07 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  April 26, 2016 at 08:20:39 PM by AutoGen 5.18.5
  *  From the definitions    sntp-opts.def
  *  and the template file   options
  *
@@ -70,7 +70,7 @@
  *  static const strings for sntp options
  */
 static char const sntp_opt_strs[2549] =
-/*     0 */ "sntp 4.2.8p6\n"
+/*     0 */ "sntp 4.2.8p7\n"
             "Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
@@ -155,7 +155,7 @@
 /*  2298 */ "LOAD_OPTS\0"
 /*  2308 */ "no-load-opts\0"
 /*  2321 */ "SNTP\0"
-/*  2326 */ "sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p6\n"
+/*  2326 */ "sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p7\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n"
             "\t\t[ hostname-or-IP ...]\n\0"
 /*  2485 */ "$HOME\0"
@@ -163,7 +163,7 @@
 /*  2493 */ ".ntprc\0"
 /*  2500 */ "http://bugs.ntp.org, bugs@ntp.org\0"
 /*  2534 */ "\n\0"
-/*  2536 */ "sntp 4.2.8p6";
+/*  2536 */ "sntp 4.2.8p7";
 
 /**
  *  ipv4 option description with
@@ -1173,7 +1173,7 @@
      translate option names.
    */
   /* referenced via sntpOptions.pzCopyright */
-  puts(_("sntp 4.2.8p6\n\
+  puts(_("sntp 4.2.8p7\n\
 Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
@@ -1263,7 +1263,7 @@
   puts(_("load options from a config file"));
 
   /* referenced via sntpOptions.pzUsageTitle */
-  puts(_("sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p6\n\
+  puts(_("sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p7\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
 \t\t[ hostname-or-IP ...]\n"));
 
@@ -1271,7 +1271,7 @@
   puts(_("\n"));
 
   /* referenced via sntpOptions.pzFullVersion */
-  puts(_("sntp 4.2.8p6"));
+  puts(_("sntp 4.2.8p7"));
 
   /* referenced via sntpOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: contrib/ntp/tests/libntp/Makefile.am
===================================================================
--- contrib/ntp/tests/libntp/Makefile.am	(版本 297264)
+++ contrib/ntp/tests/libntp/Makefile.am	(版本 298770)
@@ -42,6 +42,7 @@
 	test-strtolfp		\
 	test-timespecops	\
 	test-timevalops		\
+	test-tsafememcmp	\
 	test-tstotv		\
 	test-tvtots		\
 	test-uglydate		\
@@ -102,6 +103,7 @@
 	$(srcdir)/run-strtolfp.c	\
 	$(srcdir)/run-timevalops.c	\
 	$(srcdir)/run-timespecops.c	\
+	$(srcdir)/run-tsafememcmp.c	\
 	$(srcdir)/run-tstotv.c		\
 	$(srcdir)/run-tvtots.c		\
 	$(srcdir)/run-uglydate.c	\
@@ -477,6 +479,16 @@
 
 ###
 
+test_tsafememcmp_SOURCES =	\
+	tsafememcmp.c		\
+	run-tsafememcmp.c	\
+	$(NULL)
+
+$(srcdir)/run-tsafememcmp.c: $(srcdir)/tsafememcmp.c $(std_unity_list)
+	$(run_unity) tsafememcmp.c run-tsafememcmp.c
+
+###
+
 test_tstotv_SOURCES =		\
 	tstotv.c		\
 	run-tstotv.c		\
Index: contrib/ntp/tests/libntp/run-timevalops.c
===================================================================
--- contrib/ntp/tests/libntp/run-timevalops.c	(版本 297264)
+++ contrib/ntp/tests/libntp/run-timevalops.c	(版本 298770)
@@ -77,34 +77,34 @@
 {
   progname = argv[0];
   UnityBegin("timevalops.c");
-  RUN_TEST(test_Helpers1, 39);
-  RUN_TEST(test_Normalise, 40);
-  RUN_TEST(test_SignNoFrac, 41);
-  RUN_TEST(test_SignWithFrac, 42);
-  RUN_TEST(test_CmpFracEQ, 43);
-  RUN_TEST(test_CmpFracGT, 44);
-  RUN_TEST(test_CmpFracLT, 45);
-  RUN_TEST(test_AddFullNorm, 46);
-  RUN_TEST(test_AddFullOflow1, 47);
-  RUN_TEST(test_AddUsecNorm, 48);
-  RUN_TEST(test_AddUsecOflow1, 49);
-  RUN_TEST(test_SubFullNorm, 50);
-  RUN_TEST(test_SubFullOflow, 51);
-  RUN_TEST(test_SubUsecNorm, 52);
-  RUN_TEST(test_SubUsecOflow, 53);
-  RUN_TEST(test_Neg, 54);
-  RUN_TEST(test_AbsNoFrac, 55);
-  RUN_TEST(test_AbsWithFrac, 56);
-  RUN_TEST(test_Helpers2, 57);
-  RUN_TEST(test_ToLFPbittest, 58);
-  RUN_TEST(test_ToLFPrelPos, 59);
-  RUN_TEST(test_ToLFPrelNeg, 60);
-  RUN_TEST(test_ToLFPabs, 61);
-  RUN_TEST(test_FromLFPbittest, 62);
-  RUN_TEST(test_FromLFPrelPos, 63);
-  RUN_TEST(test_FromLFPrelNeg, 64);
-  RUN_TEST(test_LFProundtrip, 65);
-  RUN_TEST(test_ToString, 66);
+  RUN_TEST(test_Helpers1, 37);
+  RUN_TEST(test_Normalise, 38);
+  RUN_TEST(test_SignNoFrac, 39);
+  RUN_TEST(test_SignWithFrac, 40);
+  RUN_TEST(test_CmpFracEQ, 41);
+  RUN_TEST(test_CmpFracGT, 42);
+  RUN_TEST(test_CmpFracLT, 43);
+  RUN_TEST(test_AddFullNorm, 44);
+  RUN_TEST(test_AddFullOflow1, 45);
+  RUN_TEST(test_AddUsecNorm, 46);
+  RUN_TEST(test_AddUsecOflow1, 47);
+  RUN_TEST(test_SubFullNorm, 48);
+  RUN_TEST(test_SubFullOflow, 49);
+  RUN_TEST(test_SubUsecNorm, 50);
+  RUN_TEST(test_SubUsecOflow, 51);
+  RUN_TEST(test_Neg, 52);
+  RUN_TEST(test_AbsNoFrac, 53);
+  RUN_TEST(test_AbsWithFrac, 54);
+  RUN_TEST(test_Helpers2, 55);
+  RUN_TEST(test_ToLFPbittest, 56);
+  RUN_TEST(test_ToLFPrelPos, 57);
+  RUN_TEST(test_ToLFPrelNeg, 58);
+  RUN_TEST(test_ToLFPabs, 59);
+  RUN_TEST(test_FromLFPbittest, 60);
+  RUN_TEST(test_FromLFPrelPos, 61);
+  RUN_TEST(test_FromLFPrelNeg, 62);
+  RUN_TEST(test_LFProundtrip, 63);
+  RUN_TEST(test_ToString, 64);
 
   return (UnityEnd());
 }
Index: contrib/ntp/tests/libntp/timevalops.c
===================================================================
--- contrib/ntp/tests/libntp/timevalops.c	(版本 297264)
+++ contrib/ntp/tests/libntp/timevalops.c	(版本 298770)
@@ -27,8 +27,6 @@
 	u_int32	frac;
 } lfpfracdata ;
 
-typedef int bool;
-
 struct timeval timeval_init( time_t hi, long lo);
 const bool timeval_isValid(struct timeval V);
 l_fp l_fp_init(int32 i, u_int32 f);
Index: contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc
===================================================================
--- contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc	(版本 297264)
+++ contrib/ntp/util/ntp-keygen.1ntp-keygenmdoc	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt NTP_KEYGEN 1ntp-keygenmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:19:51 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:30:23 PM by AutoGen 5.18.5
 .\"  From the definitions    ntp-keygen-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/sntp/crypto.c
===================================================================
--- contrib/ntp/sntp/crypto.c	(版本 297264)
+++ contrib/ntp/sntp/crypto.c	(版本 298770)
@@ -1,6 +1,7 @@
 #include <config.h>
 #include "crypto.h"
 #include <ctype.h>
+#include "isc/string.h"
 
 struct key *key_ptr;
 size_t key_cnt = 0;
@@ -56,11 +57,16 @@
 	pkt_ptr = pkt_data;
 	hash_len = make_mac(pkt_ptr, pkt_size, sizeof(digest), cmp_key,
 			    digest);
-	if (!hash_len)
+	if (!hash_len) {
 		authentic = FALSE;
-	else
-		authentic = !memcmp(digest, pkt_ptr + pkt_size + 4,
+	} else {
+		/* isc_tsmemcmp will be better when its easy to link
+		 * with.  sntp is a 1-shot program, so snooping for
+		 * timing attacks is Harder.
+		 */
+		authentic = !memcmp(digest, pkt_data + pkt_size + 4,
 				    hash_len);
+	}
 	return authentic;
 }
 
Index: contrib/ntp/sntp/m4/ntp_libntp.m4
===================================================================
--- contrib/ntp/sntp/m4/ntp_libntp.m4	(版本 297264)
+++ contrib/ntp/sntp/m4/ntp_libntp.m4	(版本 298770)
@@ -163,6 +163,7 @@
 	# include <sys/socket.h>
 	#endif
     ])
+    AC_DEFINE([NEED_EARLY_FORK], [1], [having to fork the DNS worker early when doing chroot?])
 esac
 
 AC_CHECK_HEADERS([arpa/nameser.h sys/param.h sys/time.h sys/timers.h])
Index: contrib/ntp/sntp/sntp.1sntpman
===================================================================
--- contrib/ntp/sntp/sntp.1sntpman	(版本 297264)
+++ contrib/ntp/sntp/sntp.1sntpman	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp 1sntpman "20 Jan 2016" "4.2.8p6" "User Commands"
+.TH sntp 1sntpman "26 Apr 2016" "4.2.8p7" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-vxaitn/ag-Ixaasn)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-EjaOrb/ag-RjaGqb)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:06:38 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:21:08 PM by AutoGen 5.18.5
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/sntp/sntp.mdoc.in
===================================================================
--- contrib/ntp/sntp/sntp.mdoc.in	(版本 297264)
+++ contrib/ntp/sntp/sntp.mdoc.in	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt SNTP @SNTP_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (sntp-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:06:45 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:21:15 PM by AutoGen 5.18.5
 .\"  From the definitions    sntp-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/tests/libntp/lfpfunc.c
===================================================================
--- contrib/ntp/tests/libntp/lfpfunc.c	(版本 297264)
+++ contrib/ntp/tests/libntp/lfpfunc.c	(版本 298770)
@@ -21,9 +21,6 @@
 }
 
 
-typedef int bool; // typedef enum { FALSE, TRUE } boolean; -> can't use this because TRUE and FALSE are already defined
-
-
 typedef struct  {
 	uint32_t h, l;
 } lfp_hl;
Index: contrib/ntp/tests/libntp/ssl_init.c
===================================================================
--- contrib/ntp/tests/libntp/ssl_init.c	(版本 297264)
+++ contrib/ntp/tests/libntp/ssl_init.c	(版本 298770)
@@ -43,7 +43,7 @@
 	size_t digestLength;
 	size_t expected = TEST_SHA1_DIGEST_LENGTH;
 
-	TEST_ASSERT_EQUAL(NID_sha, keytype_from_text("SHA", &digestLength));
+	TEST_ASSERT_EQUAL(NID_sha1, keytype_from_text("SHA1", &digestLength));
 	TEST_ASSERT_EQUAL(expected, digestLength);
 	/* OPENSSL */
 #else 
@@ -62,7 +62,7 @@
 void
 test_SHA1KeyName(void) {
 #ifdef OPENSSL
-	TEST_ASSERT_EQUAL_STRING("SHA", keytype_name(NID_sha));
+	TEST_ASSERT_EQUAL_STRING("SHA1", keytype_name(NID_sha1));
 #else
 	TEST_IGNORE_MESSAGE("Skipping because OPENSSL isn't defined");
 #endif	/* OPENSSL */
Index: contrib/ntp/tests/ntpq/Makefile.am
===================================================================
--- contrib/ntp/tests/ntpq/Makefile.am	(版本 297264)
+++ contrib/ntp/tests/ntpq/Makefile.am	(版本 298770)
@@ -34,6 +34,7 @@
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
 AM_CPPFLAGS += -DUNITY_INCLUDE_CONFIG_H
 AM_CPPFLAGS += -I$(top_srcdir)/sntp/unity
+AM_CPPFLAGS += $(LIBOPTS_CFLAGS)
 
 AM_LDFLAGS = $(LDFLAGS_NTP)
 
Index: contrib/ntp/scripts/ntp-wait/ntp-wait-opts
===================================================================
--- contrib/ntp/scripts/ntp-wait/ntp-wait-opts	(版本 297264)
+++ contrib/ntp/scripts/ntp-wait/ntp-wait-opts	(版本 298770)
@@ -1,6 +1,6 @@
 # EDIT THIS FILE WITH CAUTION  (ntp-wait-opts)
 #
-# It has been AutoGen-ed  January 20, 2016 at 04:09:51 AM by AutoGen 5.18.5
+# It has been AutoGen-ed  April 26, 2016 at 08:24:18 PM by AutoGen 5.18.5
 # From the definitions    ntp-wait-opts.def
 # and the template file   perlopt
 
@@ -40,7 +40,7 @@
         'help|?', 'more-help'));
 
     $usage = <<'USAGE';
-ntp-wait - Wait for ntpd to stabilize the system clock - Ver. 4.2.8p6
+ntp-wait - Wait for ntpd to stabilize the system clock - Ver. 4.2.8p7
 USAGE: ntp-wait [ -<flag> [<val>] | --<name>[{=| }<val>] ]... 
 
     -n, --tries=num              Number of times to check ntpd
Index: contrib/ntp/scripts/ntp-wait/ntp-wait.man.in
===================================================================
--- contrib/ntp/scripts/ntp-wait/ntp-wait.man.in	(版本 297264)
+++ contrib/ntp/scripts/ntp-wait/ntp-wait.man.in	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp-wait @NTP_WAIT_MS@ "20 Jan 2016" "ntp (4.2.8p6)" "User Commands"
+.TH ntp-wait @NTP_WAIT_MS@ "26 Apr 2016" "ntp (4.2.8p7)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-4fay4H/ag-fgaG3H)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-LcaO9v/ag-XcaW8v)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:09:53 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:24:20 PM by AutoGen 5.18.5
 .\" From the definitions ntp-wait-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/scripts/ntpsweep/ntpsweep.1ntpsweepman
===================================================================
--- contrib/ntp/scripts/ntpsweep/ntpsweep.1ntpsweepman	(版本 297264)
+++ contrib/ntp/scripts/ntpsweep/ntpsweep.1ntpsweepman	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpsweep 1ntpsweepman "20 Jan 2016" "ntp (4.2.8p6)" "User Commands"
+.TH ntpsweep 1ntpsweepman "26 Apr 2016" "ntp (4.2.8p7)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-3aaGuJ/ag-ebaOtJ)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-L6aGzx/ag-Y6aOyx)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:10:05 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:24:32 PM by AutoGen 5.18.5
 .\" From the definitions ntpsweep-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/scripts/ntpsweep/ntpsweep.mdoc.in
===================================================================
--- contrib/ntp/scripts/ntpsweep/ntpsweep.mdoc.in	(版本 297264)
+++ contrib/ntp/scripts/ntpsweep/ntpsweep.mdoc.in	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt NTPSWEEP 1ntpsweepmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpsweep-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:10:09 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:24:35 PM by AutoGen 5.18.5
 .\"  From the definitions    ntpsweep-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/scripts/ntptrace/ntptrace.1ntptracemdoc
===================================================================
--- contrib/ntp/scripts/ntptrace/ntptrace.1ntptracemdoc	(版本 297264)
+++ contrib/ntp/scripts/ntptrace/ntptrace.1ntptracemdoc	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt NTPTRACE 1ntptracemdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntptrace-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:10:18 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:24:44 PM by AutoGen 5.18.5
 .\"  From the definitions    ntptrace-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/scripts/plot_summary.man.in
===================================================================
--- contrib/ntp/scripts/plot_summary.man.in	(版本 297264)
+++ contrib/ntp/scripts/plot_summary.man.in	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH plot_summary 1plot_summaryman "20 Jan 2016" "ntp (4.2.8p6)" "User Commands"
+.TH plot_summary 1plot_summaryman "26 Apr 2016" "ntp (4.2.8p7)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-CNaiCN/ag-PNaqBN)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-gsaiHB/ag-ssaqGB)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:10:36 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:25:02 PM by AutoGen 5.18.5
 .\" From the definitions plot_summary-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/scripts/summary.1summarymdoc
===================================================================
--- contrib/ntp/scripts/summary.1summarymdoc	(版本 297264)
+++ contrib/ntp/scripts/summary.1summarymdoc	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt SUMMARY 1summarymdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (summary-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:10:44 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:25:09 PM by AutoGen 5.18.5
 .\"  From the definitions    summary-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/sntp/sntp-opts.h
===================================================================
--- contrib/ntp/sntp/sntp-opts.h	(版本 297264)
+++ contrib/ntp/sntp/sntp-opts.h	(版本 298770)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (sntp-opts.h)
  *
- *  It has been AutoGen-ed  January 20, 2016 at 04:06:06 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  April 26, 2016 at 08:20:38 PM by AutoGen 5.18.5
  *  From the definitions    sntp-opts.def
  *  and the template file   options
  *
@@ -91,9 +91,9 @@
 /** count of all options for sntp */
 #define OPTION_CT    23
 /** sntp version */
-#define SNTP_VERSION       "4.2.8p6"
+#define SNTP_VERSION       "4.2.8p7"
 /** Full sntp version text */
-#define SNTP_FULL_VERSION  "sntp 4.2.8p6"
+#define SNTP_FULL_VERSION  "sntp 4.2.8p7"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/sntp/sntp.man.in
===================================================================
--- contrib/ntp/sntp/sntp.man.in	(版本 297264)
+++ contrib/ntp/sntp/sntp.man.in	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp @SNTP_MS@ "20 Jan 2016" "4.2.8p6" "User Commands"
+.TH sntp @SNTP_MS@ "26 Apr 2016" "4.2.8p7" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-vxaitn/ag-Ixaasn)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-EjaOrb/ag-RjaGqb)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:06:38 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:21:08 PM by AutoGen 5.18.5
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/tests/libntp/tsafememcmp.c
===================================================================
--- contrib/ntp/tests/libntp/tsafememcmp.c	(不存在的)
+++ contrib/ntp/tests/libntp/tsafememcmp.c	(版本 298770)
@@ -0,0 +1,85 @@
+#include "config.h"
+
+#include "ntp_stdlib.h"
+#include "isc/string.h"
+
+#include "unity.h"
+
+/* Basisc test for timingsafe_memcmp() */
+
+void test_Empty(void);
+void test_Equal(void);
+void test_FirstByte(void);
+void test_LastByte(void);
+void test_MiddleByte(void);
+void test_MiddleByteUpLo(void);
+
+void test_Empty(void)
+{
+	static const char dummy[1];
+	TEST_ASSERT_EQUAL_INT(0, isc_tsmemcmp(NULL , NULL , 0));
+	TEST_ASSERT_EQUAL_INT(0, isc_tsmemcmp(dummy, dummy, 0));
+}
+
+void test_Equal(void)
+{
+	static const char dummy[2][4] = {
+		"blob", "blob"
+	};
+	TEST_ASSERT_EQUAL_INT(0, isc_tsmemcmp(dummy[0],
+					      dummy[1],
+					      sizeof(dummy[0])));
+}
+
+void test_FirstByte(void)
+{
+	static const char dummy[2][4] = {
+		"Blob", "Clob"
+	};
+	TEST_ASSERT_EQUAL_INT(-1, isc_tsmemcmp(dummy[0],
+					       dummy[1],
+					       sizeof(dummy[0])));
+	TEST_ASSERT_EQUAL_INT( 1, isc_tsmemcmp(dummy[1],
+					       dummy[0],
+					       sizeof(dummy[0])));
+}
+
+void test_LastByte(void)
+{
+	static const char dummy[2][4] = {
+		"Blob", "Bloc"
+	};
+	TEST_ASSERT_EQUAL_INT(-1, isc_tsmemcmp(dummy[0],
+					       dummy[1],
+					       sizeof(dummy[0])));
+	TEST_ASSERT_EQUAL_INT( 1, isc_tsmemcmp(dummy[1],
+					       dummy[0],
+					       sizeof(dummy[0])));
+}
+
+void test_MiddleByte(void)
+{
+	static const char dummy[2][4] = {
+		"Blob", "Blpb"
+	};
+	TEST_ASSERT_EQUAL_INT(-1, isc_tsmemcmp(dummy[0],
+					       dummy[1],
+					       sizeof(dummy[0])));
+	TEST_ASSERT_EQUAL_INT( 1, isc_tsmemcmp(dummy[1],
+					       dummy[0],
+					       sizeof(dummy[0])));
+}
+
+void test_MiddleByteUpLo(void)
+{
+	static const char dummy[2][4] = {
+		"Blob", "Blpa"
+	};
+	TEST_ASSERT_EQUAL_INT(-1, isc_tsmemcmp(dummy[0],
+					       dummy[1],
+					       sizeof(dummy[0])));
+	TEST_ASSERT_EQUAL_INT( 1, isc_tsmemcmp(dummy[1],
+					       dummy[0],
+					       sizeof(dummy[0])));
+}
+
Index: contrib/ntp/util/ntp-keygen-opts.c
===================================================================
--- contrib/ntp/util/ntp-keygen-opts.c	(版本 297264)
+++ contrib/ntp/util/ntp-keygen-opts.c	(版本 298770)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.c)
  *
- *  It has been AutoGen-ed  January 20, 2016 at 04:19:33 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  April 26, 2016 at 08:30:03 PM by AutoGen 5.18.5
  *  From the definitions    ntp-keygen-opts.def
  *  and the template file   options
  *
@@ -72,7 +72,7 @@
  *  static const strings for ntp-keygen options
  */
 static char const ntp_keygen_opt_strs[2419] =
-/*     0 */ "ntp-keygen (ntp) 4.2.8p6\n"
+/*     0 */ "ntp-keygen (ntp) 4.2.8p7\n"
             "Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
@@ -164,7 +164,7 @@
 /*  2202 */ "no-load-opts\0"
 /*  2215 */ "no\0"
 /*  2218 */ "NTP_KEYGEN\0"
-/*  2229 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p6\n"
+/*  2229 */ "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p7\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n\0"
 /*  2343 */ "$HOME\0"
 /*  2349 */ ".\0"
@@ -171,7 +171,7 @@
 /*  2351 */ ".ntprc\0"
 /*  2358 */ "http://bugs.ntp.org, bugs@ntp.org\0"
 /*  2392 */ "\n\0"
-/*  2394 */ "ntp-keygen (ntp) 4.2.8p6";
+/*  2394 */ "ntp-keygen (ntp) 4.2.8p7";
 
 /**
  *  imbits option description:
@@ -1309,7 +1309,7 @@
      translate option names.
    */
   /* referenced via ntp_keygenOptions.pzCopyright */
-  puts(_("ntp-keygen (ntp) 4.2.8p6\n\
+  puts(_("ntp-keygen (ntp) 4.2.8p7\n\
 Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
@@ -1408,7 +1408,7 @@
   puts(_("load options from a config file"));
 
   /* referenced via ntp_keygenOptions.pzUsageTitle */
-  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p6\n\
+  puts(_("ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.8p7\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n"));
 
   /* referenced via ntp_keygenOptions.pzExplain */
@@ -1415,7 +1415,7 @@
   puts(_("\n"));
 
   /* referenced via ntp_keygenOptions.pzFullVersion */
-  puts(_("ntp-keygen (ntp) 4.2.8p6"));
+  puts(_("ntp-keygen (ntp) 4.2.8p7"));
 
   /* referenced via ntp_keygenOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: usr.sbin/ntp/config.h
===================================================================
--- usr.sbin/ntp/config.h	(版本 297264)
+++ usr.sbin/ntp/config.h	(版本 298770)
@@ -304,9 +304,15 @@
 /* The number of minutes in a DST adjustment */
 #define DSTMINUTES 60
 
+/* support dynamic interleave? */
+#define DYNAMIC_INTERLEAVE 0
+
 /* number of args to el_init() */
 #define EL_INIT_ARGS 4
 
+/* Provide the explicit 127.0.0.0/8 martian filter? */
+#define ENABLE_BUG3020_FIX 1
+
 /* nls support in libopts */
 /* #undef ENABLE_NLS */
 
@@ -832,7 +838,7 @@
 /* Define to 1 if you have the <stdatomic.h> header file. */
 #define HAVE_STDATOMIC_H 1
 
-/* Define to 1 if you have the <stdbool.h> header file. */
+/* Define to 1 if stdbool.h conforms to C99. */
 #define HAVE_STDBOOL_H 1
 
 /* Define to 1 if you have the <stddef.h> header file. */
@@ -1203,6 +1209,9 @@
 /* define if select implicitly yields */
 #define HAVE_YIELDING_SELECT 1
 
+/* Define to 1 if the system has the type `_Bool'. */
+#define HAVE__BOOL 1
+
 /* Define to 1 if you have the `_exit' function. */
 #define HAVE__EXIT 1
 
@@ -1349,6 +1358,9 @@
    initialization. */
 /* #undef MISSING_C99_STRUCT_INIT */
 
+/* having to fork the DNS worker early when doing chroot? */
+/* #undef NEED_EARLY_FORK */
+
 /* Do we need HPUX adjtime() library support? */
 /* #undef NEED_HPUX_ADJTIME */
 
@@ -1437,7 +1449,7 @@
 #define PACKAGE_NAME "ntp"
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "ntp 4.2.8p6"
+#define PACKAGE_STRING "ntp 4.2.8p7"
 
 /* Define to the one symbol short name of this package. */
 #define PACKAGE_TARNAME "ntp"
@@ -1446,7 +1458,7 @@
 #define PACKAGE_URL "http://www.ntp.org./"
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "4.2.8p6"
+#define PACKAGE_VERSION "4.2.8p7"
 
 /* data dir */
 #define PERLLIBDIR "/usr/local/share/ntp/lib"
@@ -1487,7 +1499,7 @@
 /* Do we want the SCO clock hacks? */
 /* #undef SCO5_CLOCK */
 
-/* The size of `char*', as computed by sizeof. */
+/* The size of `char *', as computed by sizeof. */
 #ifdef __LP64__
 #define SIZEOF_CHARP 8
 #else
@@ -1627,7 +1639,7 @@
 /* #undef USE_UDP_SIGPOLL */
 
 /* Version number of package */
-#define VERSION "4.2.8p6"
+#define VERSION "4.2.8p7"
 
 /* vsnprintf expands "%m" to strerror(errno) */
 /* #undef VSNPRINTF_PERCENT_M */
@@ -1804,5 +1816,5 @@
 /*
  * FreeBSD specific: Explicitly specify date/time for reproducible build.
  */
-#define	MKREPRO_DATE "Jan 21 2016"
-#define	MKREPRO_TIME "01:03:28"
+#define	MKREPRO_DATE "Apr 27 2016"
+#define	MKREPRO_TIME "05:53:49"
Index: usr.sbin/ntp/libntp/Makefile
===================================================================
--- usr.sbin/ntp/libntp/Makefile	(版本 297264)
+++ usr.sbin/ntp/libntp/Makefile	(版本 298770)
@@ -41,7 +41,8 @@
 	stdio.c \
 	stdtime.c \
 	strerror.c \
-	time.c
+	time.c \
+	tsmemcmp.c
 
 ISC_NLS_SRCS= msgcat.c
 
Index: contrib/ntp/util/ntp-keygen.mdoc.in
===================================================================
--- contrib/ntp/util/ntp-keygen.mdoc.in	(版本 297264)
+++ contrib/ntp/util/ntp-keygen.mdoc.in	(版本 298770)
@@ -1,9 +1,9 @@
-.Dd January 20 2016
+.Dd April 26 2016
 .Dt NTP_KEYGEN @NTP_KEYGEN_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  January 20, 2016 at 04:19:51 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  April 26, 2016 at 08:30:23 PM by AutoGen 5.18.5
 .\"  From the definitions    ntp-keygen-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: sys/conf/newvers.sh
===================================================================
--- sys/conf/newvers.sh	(版本 297264)
+++ sys/conf/newvers.sh	(版本 298770)
@@ -32,7 +32,7 @@
 
 TYPE="FreeBSD"
 REVISION="10.3"
-BRANCH="RELEASE"
+BRANCH="RELEASE-p1"
 if [ "X${BRANCH_OVERRIDE}" != "X" ]; then
 	BRANCH=${BRANCH_OVERRIDE}
 fi
Index: contrib/ntp/util/ntp-keygen-opts.h
===================================================================
--- contrib/ntp/util/ntp-keygen-opts.h	(版本 297264)
+++ contrib/ntp/util/ntp-keygen-opts.h	(版本 298770)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntp-keygen-opts.h)
  *
- *  It has been AutoGen-ed  January 20, 2016 at 04:19:32 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  April 26, 2016 at 08:30:02 PM by AutoGen 5.18.5
  *  From the definitions    ntp-keygen-opts.def
  *  and the template file   options
  *
@@ -94,9 +94,9 @@
 /** count of all options for ntp-keygen */
 #define OPTION_CT    26
 /** ntp-keygen version */
-#define NTP_KEYGEN_VERSION       "4.2.8p6"
+#define NTP_KEYGEN_VERSION       "4.2.8p7"
 /** Full ntp-keygen version text */
-#define NTP_KEYGEN_FULL_VERSION  "ntp-keygen (ntp) 4.2.8p6"
+#define NTP_KEYGEN_FULL_VERSION  "ntp-keygen (ntp) 4.2.8p7"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/util/ntp-keygen.man.in
===================================================================
--- contrib/ntp/util/ntp-keygen.man.in	(版本 297264)
+++ contrib/ntp/util/ntp-keygen.man.in	(版本 298770)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp-keygen @NTP_KEYGEN_MS@ "20 Jan 2016" "ntp (4.2.8p6)" "User Commands"
+.TH ntp-keygen @NTP_KEYGEN_MS@ "26 Apr 2016" "ntp (4.2.8p7)" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Dua4pY/ag-PuaWoY)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-FRa4eL/ag-RRaWdL)
 .\"
-.\" It has been AutoGen-ed January 20, 2016 at 04:19:44 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed April 26, 2016 at 08:30:15 PM by AutoGen 5.18.5
 .\" From the definitions ntp-keygen-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: usr.sbin/ntp/scripts/mkver
===================================================================
--- usr.sbin/ntp/scripts/mkver	(版本 297264)
+++ usr.sbin/ntp/scripts/mkver	(版本 298770)
@@ -6,7 +6,7 @@
 
 ConfStr="$PROG"
 
-ConfStr="$ConfStr 4.2.8p6"
+ConfStr="$ConfStr 4.2.8p7"
 
 case "$CSET" in
  '') ;;
